# -*- coding: utf-8 -*-
##############################################
#
# Swing Entwicklung betrieblicher Informationssysteme GmbH
# (<http://www.swing-system.com>)
# Copyright (C) ChriCar Beteiligungs- und Beratungs- GmbH
# all rights reserved
#    16-SEP-2009 (GK) created
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs.
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company.
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 3
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/> or
# write to the Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
###############################################
from osv import fields,osv
from tools.translate import _
import os

class dimu_constraint (osv.osv):
    _name = "dimu.constraint"

    _columns  = \
        { 'condition' : fields.char ('Condition', required=True, size=256)
        , 'filter'    : fields.char ('Filter', size=256)
        , 'name'      : fields.char ('Error Message', required=True, size=128)
        , 'object'    : fields.char ('Object', required=True, size=32)
        , 'table'     : fields.char ('Table', required=True, size=32)
        }

    def test_obj (self, cr, uid, rule, obj) : pass # let the heirs do the work

    def test (self, cr, uid, rule) :
        result = []
        c_obj = self.pool.get (rule.table)
        c_ids = c_obj.search (cr, uid, [])
        for obj in c_obj.browse (cr, uid, c_ids) :
            result.extend(self.test_obj(cr, uid, rule, obj))
        return result
    # end def test

    def button_test (self, cr, uid, ids, id) :
        result = []
        for c in self.browse (cr, uid, ids) :
            result.extend(self.test(cr, uid, c))
        if result :
            raise osv.except_osv (_('Rule Error !'), _('\n'.join (result)))
        else :
            raise osv.except_osv (_('Rule successfully tested !'), _('No errors found.'))
    # end def button_test
    
dimu_constraint ()

class dimu_check_one (osv.osv):
    _name     = "dimu.check_one"
    _inherit  = "dimu.constraint"

    def test_obj (self, cr, uid, rule, obj) :
        result = []
        c_obj = self.pool.get (rule.table)
        ctx = {rule.object : obj, 'os' : os, 'mappings' : lambda *a: [1,2]}
        if rule.filter :
            if eval (rule.filter, {rule.object : obj}):
                if not eval (rule.condition, ctx):
                    result.append("%s: %s '%s'" % (c_obj._description, obj.name, rule.name))
        else :
            if not eval (rule.condition, ctx):
                result.append("%s: %s '%s'" % (c_obj._description, obj.name, rule.name))
        return result
    # end def test

dimu_check_one ()

class dimu_check_for_all (osv.osv):
    _name     = "dimu.check_for_all"
    _inherit  = "dimu.constraint"

    _columns  = \
        { 'sequence' : fields.char ('Sequence', size=256, required=True)
        , 'var'      : fields.char ('Variable', size=32,  required=True)
        }

    def test_obj (self, cr, uid, rule, obj) :
        result = []
        c_obj = self.pool.get (rule.table)
        dict = {rule.object : obj, 'os' : os}
        if rule.filter :
            if eval (rule.filter, dict):
                seq = eval (rule.sequence, dict)
                for elem in seq :
                    ctx = {rule.var : elem, 'mappings' : lambda *a: [1,2]}
                    ctx.update(dict)
                    if not eval (rule.condition, ctx):
                        result.append("%s: %s '%s' %s" % (c_obj._description, obj.name, rule.name, elem.name))
        else :
            seq = eval (rule.sequence, dict)
            for elem in seq :
                ctx = {rule.var : elem, 'mappings' : lambda *a: [1,2]}
                ctx.update(dict)
                if not eval (rule.condition, ctx):
                    result.append("%s: %s '%s' %s" % (c_obj._description, obj.name, rule.name, elem.name))
        return result
    # end def test_obj



dimu_check_for_all ()
